var gFunctionAuthenticator = require('letsnet-graphed').functionAuth

module.exports = function(defaults) {
    var model = {}

    model.gAuthenticateFunction = function(object, queue) {
        gFunctionAuthenticator({appid: object.appid || '---'}).authenticateFunction({functionID: object.functionID || '---', email: object.email || '---'}, function(error, document) {
            delete object['functionID']; delete object['appid']
            if(error) queue.stop({lCode: document.lCode, msg: document.msg, type: 'authentication-error'})
            else queue.next()
        })
    }

    model.prepareApikey = function(object, queue) {
        if(object.apikey === undefined) queue.stop({type: 'authentication-error', msg: 'Nem található apikey!'})
        else {
            object.apikey = object.apikey.slice(7)
            queue.next()
        }
    }

    return model
}